package myPkg;

import java.util.Collection;
import java.util.Iterator;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.resource.UMLResource;

public class Reader {

	private String file_name;
	
	Reader(String name)
	{
		file_name = name;
	}
	
	public void loadModel() {

		ResourceSet resourceSet = new ResourceSetImpl();
		resourceSet.getPackageRegistry().put(UMLPackage.eNS_URI,
				UMLPackage.eINSTANCE);

		resourceSet.getResourceFactoryRegistry().getExtensionToFactoryMap()
				.put(UMLResource.FILE_EXTENSION, UMLResource.Factory.INSTANCE);

		URI uri = URI.createURI("models" + System.getProperty("file.separator")
				+ this.file_name);

		
		Resource resource = resourceSet.getResource(uri, true);

		Collection<?> packages = EcoreUtil.getObjectsByType(
				resource.getContents(), UMLPackage.Literals.PACKAGE);

		Iterator<?> it = packages.iterator();
		
		System.out.println("Checking packages?");
		while (it.hasNext()) {
			
			System.out.println("Enter a package");
		
			org.eclipse.uml2.uml.Package p = (org.eclipse.uml2.uml.Package) it
					.next();

			System.out.println(" Within package " + p.getName());
			System.out.println("Classes: ");
			System.out.println("-------------------------");
			Collection<?> classes = EcoreUtil.getObjectsByType(
					p.getPackagedElements(), UMLPackage.Literals.CLASS);
			Iterator<?> it2 = classes.iterator();
			while (it2.hasNext()) {
				org.eclipse.uml2.uml.Class c = (org.eclipse.uml2.uml.Class) it2
						.next();
				System.out.println(c.getName());
			}

			System.out.println("Associations: ");
			System.out.println("-------------------------");
			Collection<?> associations = EcoreUtil.getObjectsByType(
					p.getPackagedElements(), UMLPackage.Literals.ASSOCIATION);
			it2 = associations.iterator();
			while (it2.hasNext()) {
				Association c = (Association) it2.next();
				System.out.println(c);
			}

		}

		System.out.println("Done in Load");
	}

}

